package com.bsoft.api.service.Impl;

import com.bsoft.api.common.enums.StateType;
import com.bsoft.api.common.enums.TypeState;
import com.bsoft.api.mapper.SerProjMapper;
import com.bsoft.api.mapper.SerProjValueMapper;
import com.bsoft.api.model.SerProjValue;
import com.bsoft.api.model.reqmodel.AddBudgetValue;
import com.bsoft.api.model.respmodel.ProjectInfo;
import com.bsoft.api.model.respmodel.ProjectValue;
import com.bsoft.api.model.respmodel.SerProjValueResp;
import com.bsoft.api.service.SerProjValueService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class SerProjValueServiceImpl implements SerProjValueService {
    @Resource
    private SerProjMapper serProjMapper;
    @Resource
    private SerProjValueMapper serProjValueMapper;

    //查询项目数值
    @Override
    public Object getValue(Integer projectType,Integer date,String deptCode) throws Throwable {
        List<ProjectValue> result = new ArrayList<>();
        List<Map<String,Object>> enumList = TypeState.all();
        if(enumList != null && enumList.size() > 0){
            ProjectValue projectValue = null;
            List<ProjectInfo> projectInfo = null;
            for(Map<String,Object> enumInfo : enumList){
                projectValue = new ProjectValue();
                projectValue.setTypeId((Integer)enumInfo.get("value"));
                projectInfo = new ArrayList<>();
                projectInfo = serProjMapper.selectState(projectType,(Integer)enumInfo.get("value"));
                if(projectInfo != null && projectInfo.size() > 0){
                    for(ProjectInfo projInfo : projectInfo){
                        List<SerProjValueResp> values = serProjValueMapper.selectValue(projectType,(Integer)enumInfo.get("value"),
                                projInfo.getExponentId(),deptCode,date);
                        if(values != null && values.size() > 0)
                            projInfo.setProjectValues(values);
                    }
                }
                projectValue.setProject(projectInfo);
                result.add(projectValue);
            }
        }
        return result;
    }

    @Override
    public boolean save(AddBudgetValue request) {
        int result = 0;
        if(request != null){
            SerProjValue info = new SerProjValue(request);
            info.setCreateDate(new Date());
            info.setState(BigDecimal.valueOf(StateType.ON.getValue()));
            result = serProjValueMapper.insert(info);
        }
        return result > 0;
    }


}
